/**
 *    Copyright 2011 Peter Murray-Rust et. al.
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

// /*======AUTOGENERATED FROM SCHEMA; DO NOT EDIT BELOW THIS LINE ======*/
package org.xmlcml.cml.element;

import nu.xom.Element;
import nu.xom.Node;

import org.xmlcml.cml.base.CMLElement;

/**
 * An element to hold any combination of heterogeneous element children.
 *
 *
 * complexObject can be used as it stands but will often be extended by\n schema
 * definitions in dictionary entries.
 *
 * user-modifiable class autogenerated from schema if no class exists use as a
 * shell which can be edited the autogeneration software will not overwrite an
 * existing class file
 *
 */
public class CMLComplexObject extends AbstractComplexObject {

    /**
     * must give simple documentation.
     *
     *
     */

    public CMLComplexObject() {
    }

    /**
     * must give simple documentation.
     *
     * @param old
     *            CMLComplexObject to copy
     *
     */

    public CMLComplexObject(CMLComplexObject old) {
        super((AbstractComplexObject) old);
    }

    /**
     * copy node .
     *
     * @return Node
     */
    public Element copy() {
        return new CMLComplexObject(this);
    }

    /**
     * create new instance in context of parent, overridable by subclasses.
     *
     * @param parent
     *            parent of element to be constructed (ignored by default)
     * @return CMLComplexObject
     */
    public CMLElement makeElementInContext(Element parent) {
        return new CMLComplexObject();
    }
}
